from .insn_rv32i_i_type_shift import *

"""
SLLI instruction
"""

class InsnSlli(InsnRV32IITypeShift):
    def __init__(self, params):
        super().__init__(params, 0b000000, 0b001)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, self.rvfi_rs1_rdata << self.insn_shamt, 0))

        return m
