from .insn_rv32i_i_type_arith import *

"""
XORI instruction
"""

class InsnXori(InsnRV32IITypeArith):
    def __init__(self, params):
        super().__init__(params, 0b100)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, self.rvfi_rs1_rdata ^ self.insn_imm, 0))

        return m
