from .insn_rv32i_i_type_shift import *

"""
SRAI instruction
"""

class InsnSrai(InsnRV32IITypeShift):
    def __init__(self, params):
        super().__init__(params, 0b010000, 0b101)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, (Value.as_signed(self.rvfi_rs1_rdata) >> self.insn_shamt) | (-(Value.as_signed(self.rvfi_rs1_rdata) < 0) << (self.params.xlen - self.insn_shamt)), 0))

        return m
